/*******************************************************************************
  MPLAB Harmony Application Source File
  
  Company:
    Microchip Technology Inc.
  
  File Name:
    app.c

  Summary:
    This file contains the source code for the MPLAB Harmony application.

  Description:
    This file contains the source code for the MPLAB Harmony application.  It 
    implements the logic of the application's state machine and it may call 
    API routines of other MPLAB Harmony modules in the system, such as drivers,
    system services, and middleware.  However, it does not call any of the
    system interfaces (such as the "Initialize" and "Tasks" functions) of any of
    the modules in the system or make any assumptions about when those functions
    are called.  That is the responsibility of the configuration-specific system
    files.
 *******************************************************************************/

// DOM-IGNORE-BEGIN
/*******************************************************************************
Copyright (c) 2013-2014 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 *******************************************************************************/
// DOM-IGNORE-END


// *****************************************************************************
// *****************************************************************************
// Section: Included Files 
// *****************************************************************************
// *****************************************************************************


#include "app.h"

#include "stdio.h"


APP_DATA appData;
int delay_Clock = 200000000;   //VXeNbNF200MHz
char Buf[64];
int preAdcValue;    //Oi500msecO)ɌoADϊl
int ScanMode; 
int DeviceDetect;
int LED3;

extern char Data[128];      //RN4020Mf[^obt@[  // UARTM荞݃f[^
extern int Flag_centData;   //Zg̃R}hf[^MtO
extern int Flag_Sw1; //SW1(on mikroBUS ]{[h)XCb`@ONԃtO
extern char DeviceNum[10][128];
extern int jx;  //ofoCXԍ


void delay_us(volatile unsigned int usec)        //1secx
{
        volatile  int count;

        count = (int)(delay_Clock/20000000)*usec;
        do      //@at@200MH (Clock=200000000)
        {       //delay_us(1000)F1000.4sec  delay_us(100)F100.6sec  delay_us(10):10.5sec@@delay_us(1)F1.5sec
                asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP");asm("NOP");
                asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP");

                count--;
        }while(count != 0);
}


void delay_ms(volatile unsigned int msec)        //1msecx
{
        volatile unsigned int i;         //Fat200MH (Clock=200000000)//delay_ms(1)F 1.0006msec   delay_ms(100)F100.04msec

        for(i=0; i<msec; i++)
        delay_us(1000);
}


void Write_Byte(char chr)  //1oCgM֐    //RN4020p
{
//    PLIB_USART_TransmitterByteSend(USART_ID_3, chr); //Mobt@[1oCg݁EM   
    U3TXREG = chr;  ////Mobt@[1oCg݁EM

//    while (!PLIB_USART_TransmitterIsEmpty(USART_ID_3));  //Mobt@[ɂȂ܂ő҂
    while(!U3STAbits.TRMT);   //Mobt@[ɂȂ܂ő҂
}

void WriteString(const char *str)   //񑗐M֐    //RN4020p
{
    while(*str)
    {
        Write_Byte(*str);   //f[^M
        str++;
    }
}


void Write_Byte2(char chr)  //1oCgM֐   //Tera Term p
{
//    PLIB_USART_TransmitterByteSend(USART_ID_4, chr); //Mobt@[1oCg݁EM   
    U4TXREG = chr;  ////Mobt@[1oCg݁EM 

//  while (!PLIB_USART_TransmitterIsEmpty(USART_ID_4));  //Mobt@[ɂȂ܂ő҂
    while(!U4STAbits.TRMT);   //Mobt@[ɂȂ܂ő҂
}

void WriteString2(const char *str)   //񑗐M֐   //Tera Term p
{
    while(*str)
    {
        Write_Byte2(*str);   //f[^M
        str++;
    }
}


void LCD10(void)  //LN^tւ̕\
{
    //tʃNA
    lcd_cmd(0x80);          //1ڂ̐擪
    sprintf(Buf,"                ");//
    lcd_str(Buf);                   //t\
    lcd_cmd(0xC0);          //Qsڂ̐擪
    sprintf(Buf,"                ");	//
    lcd_str(Buf);
                
    lcd_cmd(0x80);          //1ڂ̐擪
    sprintf(Buf,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c", Data[0],Data[1],Data[2],Data[3],Data[4],Data[5],Data[6],Data[7],Data[8],Data[9],Data[10],Data[11],Data[12],Data[13],Data[14],Data[15]);
    lcd_str(Buf);           // 1sڕ\
    lcd_cmd(0xC0);          //Qsڂ̐擪
  //  sprintf(Buf,"%X %X %X %X %X             ",Data[0],Data[1],Data[2],Data[3],Data[4]);	//
    sprintf(Buf,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",  Data[16],Data[17],Data[18],Data[19],Data[20],Data[21],Data[22],Data[23],Data[24],Data[25],Data[26],Data[27],Data[28],Data[29],Data[30],Data[31]);	//
    lcd_str(Buf);           // 2sڕ\
          
 //   delay_ms(100);    //Tera Term\݂̂̏ꍇ
    delay_ms(2000); //LN^t̕\𐸓ǂꍇ
}



void BtInput(void)   //BT(RN4020)̓͏
{
    char* tempStr;
    int periAdcValue;
    float periVolt;
    
    if(Flag_centData == 1)  //Zg̃f[^L
    {
        Flag_centData = 0;
                
        //tʃNA
        lcd_cmd(0x80);          //1ڂ̐擪
        sprintf(Buf,"                ");//
        lcd_str(Buf);                   //t\
        lcd_cmd(0xC0);          //Qsڂ̐擪
        sprintf(Buf,"                ");	//
        lcd_str(Buf);
    
        //tʃNA
        lcd_cmd(0x80);          //1ڂ̐擪
        sprintf(Buf,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",Data[0],Data[1],Data[2],Data[3],Data[4],Data[5],Data[6],Data[7],
                 Data[8],Data[9],Data[10],Data[11],Data[12],Data[13],Data[14],Data[15],Data[16],Data[17],Data[18],Data[19],Data[20],Data[21],Data[22]);//
        lcd_str(Buf);                   //t\
        lcd_cmd(0xC0);          //Qsڂ̐擪
        sprintf(Buf,"                ");	//
        lcd_str(Buf);
        
           //LED@ON/OFF M̏ꍇ
        if( (Data[0] =='#') &&
            (Data[1] == '1')) 
        {
            if(Data[2] == '1') LATCbits.LATC15 = 1; //LED3_
            else LATCbits.LATC15 = 0; //LED3
        }
         else if( (Data[0] =='#') && (Data[1] == '2')) //ϒRVR1̓dADϊl̏ꍇ
        {
            Data[7] = '\0'; //Data[0]-Data[6]
            tempStr = &Data[3]; //Data[3]-Data[6]𕶎
            periAdcValue = strtol(tempStr,NULL,10); //񁨐     //10F10i
            
            //I2C߁@LN^t\
            lcd_ACM1602_cmd_i2c(0x80);  //1sڂ̐擪
            sprintf(Buf,"periAdV=%d           ",periAdcValue); //obt@[ɕZbg
            lcd_ACM1602_str_i2c(Buf);
    
            periVolt =(float)periAdcValue/4095*3.3; //{g\
            lcd_ACM1602_cmd_i2c(0xC0);  //2sڂ̐擪
            sprintf(Buf,"periVolt=%.2f[V]       ",periVolt);       //Ƃăobt@[Ɏ[
            lcd_ACM1602_str_i2c(Buf);
        }
    }    
}




void SwFunc(void) //ZgPIC32MZSW̏
{  
    if(Flag_Sw1 == 1)
    {
        Flag_Sw1 = 0;
        if(LED3 == 0)
        {
            LED3 = 1;
            WriteString("#11\r\n");    //ytFɁAytFLED3̓_߂𑗐M
        }
        else
        {
             LED3 = 0;
             WriteString("#10\r\n");    //ytFɁAytFLED3̏߂𑗐M
            
        }
    }

}


void AdcFunc(void)          //ADϊA\
{
    unsigned int AdcValue;
    float Volt;
    char* strCmd;
    char numBuf[5]; 
    
    
    //ADϊJn Trigger a conversion 
    ADCCON3bits.GSWTRG = 1; //ADϊ\tgEFAgK //Global Level Software Trigger bit
    
    //ϊ҂ Wait the conversions to complete
    while (ADCDSTAT1bits.ARDY7 == 0);
           
    //ʂ̎o fetch the result
    AdcValue = ADCDATA7;
    
    if(abs(AdcValue - preAdcValue) > 125 )  //0.1v = 4095/3.3 = 124.091
                                            //ADϊl125傫ωꍇALN^XeBbN
                                            //@ZgNotification(m)    
    {
        Volt =(float)AdcValue/4095*3.3; //{g\
        sprintf(numBuf,"#20%d",AdcValue);    //
        //ԐMf[^쐬
        strCmd = strcat(numBuf,"\r\n");   //ԐMf[^̏I[\r\nǉ
        WriteString(strCmd);    //ytFɑM
    
        //Mf[^ۑ
        preAdcValue = AdcValue;       //0.1v = 4095/3.3 = 124.091
    
        //I2C߁@LN^t\
        lcd_ACM1602_cmd_i2c(0x80);  //1sڂ̐擪
        sprintf(Buf,"AdV=%u           ",AdcValue); //obt@[ɕZbg
        lcd_ACM1602_str_i2c(Buf);
    
        lcd_ACM1602_cmd_i2c(0xC0);  //2sڂ̐擪
        sprintf(Buf,"Volt=%.2f[V]       ",Volt);       //Ƃăobt@[Ɏ[
        //sprintf(Buf,"%s", strCmd);       //Ƃăobt@[Ɏ[
        lcd_ACM1602_str_i2c(Buf);
        
        delay_ms(500);
     }
}

void AD_Initialize(void)    //AN10@ADϊ֘AWX^@
{
 // Configure ADCCON1 
    ADCCON1 = 0;    //
    ADCCON1bits.FRACT = 0; // use Integer output format
    ADCCON1bits.SELRES = 3; // ADC7 resolution is 12 bits   //default
    ADCCON1bits.STRGSRC = 0; // No scan trigger. 
 
    // Configure ADCCON2
    ADCCON2 = 0;
    ADCCON2bits.SAMC = 5; // ADC7 sampling time = 5 * TAD7
    ADCCON2bits.ADCDIV = 1; // ADC7 clock freq is half of control clock = TAD7

    // Configure ADCCON3
    ADCCON3 = 0;
    ADCCON3bits.ADCSEL = 0;     //NbN\[X:PBCLK3     // Select input clock source   
    ADCCON3bits.CONCLKDIV = 1;  // Control clock frequency is half of input clock
    ADCCON3bits.VREFSEL = 0;    // Select AVdd and AVss as reference source
    ADCCON3bits.DIGEN7 = 1;     //ADC7FL               //Shared ADC (ADC7) Digital Enable bit
    ADCCON3bits.RQCNVRT = 1;    //ʃ|[g̓[h      //Individual ADC Input Conversion Request bit
    
    ADCCON3bits.ADINSEL = 10;   //̓|[g AN10 ݒ    //Analog Input Select bits  //ύX_͂
  //  ADCCON3bits.ADINSEL = 8;   //̓|[g AN8 ݒ    //Analog Input Select bits
    ADCCON3bits.SAMP = 1;       //NX2[hݒ         //Class 2 and Class 3 Analog Input Sampling Enable bit

    // No selection for dedicated ADC modules, no pre sync trigger, not sync sampling 
    ADCTRGMODE = 0;

    // Select ADC input mode //ADC INPUT MODE CONTROL REGISTER 1
    ADCIMCON1bits.SIGN8 = 0; // unsigned data format
    ADCIMCON1bits.DIFF8 = 0; // Single ended mode

    ADCTRG2bits.TRGSRC7 = 1; //AN7\tgEFAgKɐݒ    //Trigger Source for Conversion of Analog Input AN7 Select bits //K{

    // Turn the ADC on 
    ADCCON1bits.ON = 1;

    // Enable clock to analog circuit 
    ADCANCONbits.ANEN7 = 1; // Enable the clock to analog bias

    // Wait for ADC to be ready
    while(!ADCANCONbits.WKRDY7); // Wait until ADC7 is ready

    // Enable the ADC module 
    ADCCON3bits.DIGEN7 = 1; // ADC7 ADCfW^HON
}



void ConnectBLE(void)   //BLEڑ
{  
    int i;
    char tempStr0[] = "E";
    //char tempStr1[] = "//Connect\r";
    char* strCmd;
    
    WriteString("+//Echo OnOff\r");  //GR[obNݒ   //
    LCD10();
                                     
    if(strstr(&Data[0],"Echo Off") != '\0')     //Echo OffԐMĂꍇ
         WriteString("+//Echo OnOff\r");  //GR[obNݒ   //
    LCD10();
    
    WriteString("SF,1//Initialize RN4020\r");   //Ho׃Zbg
    LCD10();
    
    WriteString("SS,80000000//Set BtStd Service \r");    //
    LCD10();
    
    WriteString("SR,92000000//Set Central_MLDP_Flow Mode\r");    //ZgAMLDPAt[ݒ
                                                                    //Zg:   0x80000000
                                                                    //MLDP:         0x10000000
                                                                    //t[ :  0x02000000
    LCD10();
    
    WriteString("SN,MZ_cent1\r");  //foCX̐ݒ
    LCD10();
        
    WriteString("R,1//RN4020 Reboot\r"); //RN4020u[g
                                 
     while(strstr(&Data[0],"CMD") == '\0')
    {
       LATCbits.LATC14 = 0;  //LED2 
    };  //"CMD"܂܂镶񂪕ԐMĂ܂ő҂
                                            //Lwhile(!...)gȂꍇ@   delay_ms(2000); //K{@̎ԂZƈȌ̃R}hł܂삵ȂR}hL
                                            //    while(strstr("12CMD56","CMD") == '\0'){}; //while(0)ƂȂʉ߂ł
                                            //vs@"CMD" @"ABC": NULLstrstr()ԂAwhile(1)ƂȂʉ߂łȂ
    
    
    WriteString("+//Echo OnOff\r");  //GR[obNݒ   //
    LCD10();
    
    delay_ms(3000);
    
    ScanMode = 1;   //XL[h
    
    while(1)
    {
        WriteString("F//Start Scan\r");  //XLJn
        LCD10();
    
        delay_ms(3000);
        WriteString("X//Stop Scan\r");  //XL~
        
        //MfoCX̒Ɂ@foCX "MZ_peri1"邩`FbNB
        for(i = 0; i < (jx + 1); i++)
        {
            if((DeviceNum[i + 2][15] == 'M') && (DeviceNum[i + 2][16] == 'Z') && (DeviceNum[i + 2][17] == '_') &&
                (DeviceNum[i + 2][18] == 'p') && (DeviceNum[i + 2][19] == 'e') && (DeviceNum[i + 2][20] == 'r') && 
                    (DeviceNum[i + 2][21] == 'i') && (DeviceNum[i + 2][22] == '1') )
            {
                DeviceDetect = 1;
                break;   
            }  
        }
        
        if(DeviceDetect == 1)
        { 
            ScanMode = 0;   //XL[hI
            sprintf(Buf,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",',',DeviceNum[i + 2][13],',',
                    DeviceNum[i + 2][0],DeviceNum[i + 2][1],DeviceNum[i + 2][2],DeviceNum[i + 2][3],
                    DeviceNum[i + 2][4],DeviceNum[i + 2][5],DeviceNum[i + 2][6],DeviceNum[i + 2][7],
                    DeviceNum[i + 2][8],DeviceNum[i + 2][9],DeviceNum[i + 2][10],DeviceNum[i + 2][11]);
            strCmd = strcat(tempStr0,Buf);
      
            strCmd = strcat(strCmd,"//Connect\r");  //
                        ////  strCmd = strcat(strCmd,tempStr1);   //̂łER}hMꂸAConnectłȂ   // char tempStr1[] = "//Connect\r";
            WriteString(strCmd);  //Connect M
            LCD10();
            break;
        }
        else
        {
            jx = 0;     //ofoCXԍjxNA    DeviceNum[jx][0];
    
            for( i = 0; i < 128; i++)
            { 
                DeviceNum[2][i] = 0x00;
                DeviceNum[3][i] = 0x00;
            }
        }
    }
    
    while(strstr(&Data[0],"Connected") == '\0')
    {
         LATCbits.LATC14 = 1; //LED2
         LATCbits.LATC14 = 0; //LED2 
         //K{@ asm("NOP");ł̓_@@{}[vɐ䂪Ȃƃ_H   //LED2
    }; //ŌołB2019.8.3@19F18
                                                //"Connected"܂܂镶񂪕ԐMĂ܂ő҂
    LCD10();
    
    delay_ms(1000);
    
    LATCbits.LATC13 = 1;    //MLDP[h   //CMD/MLDPs  0FCMD[h@1FMLDP[h
    
    delay_ms(2000);
    
    WriteString("#01 Hellow !!  This is MZ_peri1 using  MLDP mode of RN4020. Can you receive this text data ? \r\n");    //MZ_peri1ւ̑M  //\a01œe
    //"#01 Hallo! This is MZ_peri1. I have received your text data.  How are you ?\r\n"     //MZ_peri1̕ԐM
    
    while(strstr(&Data[0],"#01") == '\0')
    {
         LATCbits.LATC14 = 1; //LED2    //_~[
         LATCbits.LATC14 = 0; //LED2 
    }; 
    WriteString("#02 I am fine. Thank you for response.\r\n"); //MZ_peri1ւ̕ԐM  //\a02œe
}




/*******************************************************************************
  Function:
    void APP_Initialize ( void )

  Remarks:
    See prototype in app.h.
 */

void APP_Initialize ( void )
{
    /* Place the App state machine in its initial state. */
    appData.state = APP_STATE_INIT;

    
    /* TODO: Initialize your application's state machine and other
     * parameters.
     */
    
    AD_Initialize();    //AN10@ADϊ֘AWX^@
    
    LATCbits.LATC13 = 0;    //CMD[h   //CMD/MLDPs  0FCMD[h@1FMLDP[h
    LATCbits.LATC1 = 1;     //RN4020ANeBu      //WAKE_SWs 1:ANeBu
     
    lcd_init();				// LCD
    lcd_cmd(0b00001100);    // J[\:OFF  uݸ:OFF
    lcd_clear(); 
    lcd_cmd(0x80);          //1ڂ̐擪
    sprintf(Buf,"BLE2 Click          ");//
    lcd_str(Buf);                   //t\
    lcd_cmd(0xC0);          //Qsڂ̐擪
    sprintf(Buf,"Now Running !!    ");	//
    lcd_str(Buf);           // JnbZ[W1sڕ\
    
    lcd_ACM1602_init_i2c();     //I2CC^[tF[Xt
    lcd_ACM1602_cmd_i2c(0x0C);    //J[\F0FFAuNF0FF
    
    lcd_ACM1602_cmd_i2c(0x80);  //1sڂ̐擪
    lcd_ACM1602_str_i2c("AD Convert");
    
    lcd_ACM1602_cmd_i2c(0xC0);  //2sڂ̐擪
    lcd_ACM1602_str_i2c("   AN10  VR1              ");   
    delay_ms(2000);     //@CMD@//PIC32MZւ̕ԐM
   
    ConnectBLE();  //BLEڑ
    
    

}


/******************************************************************************
  Function:
    void APP_Tasks ( void )

  Remarks:
    See prototype in app.h.
 */

void APP_Tasks ( void )
{

    /* Check the application's current state. */
    switch ( appData.state )
    {
        /* Application's initial state. */
        case APP_STATE_INIT:
        {
            bool appInitialized = true;
       
        
            if (appInitialized)
            {
                appData.state = APP_STATE_SERVICE_TASKS;
            }
            break;
        }

        case APP_STATE_SERVICE_TASKS:
        {
            BtInput();  //BT(RN4020)̓͏
            
            SwFunc();   //SW1 o

            AdcFunc();  //VR1 ADϊ
            break;
        }

        /* TODO: implement your application state machine.*/
        

        /* The default state should never be executed. */
        default:
        {
            /* TODO: Handle error in application's state machine. */
            break;
        }
    }
}

 

/*******************************************************************************
 End of File
 */
